***** Linear Equation by TBC *****

integer n,i,j,k,l
real a0,b0,x0,p0,s0
dim a0(79,79),b0(79),x0(79)

print "Linear Equation by Gauss Method"
print
input "Data file name:",f$
open f$

read n: *** dimension
n=n-1
for i=0 to n
  for j=0 to n
    read a0(i,j)
  next j
  read b0(i)
next i

for k=0 to n-1
  *** pivoting
  p0=0
  l=k
  for i=k+1 to n
    if p0<abs(a0(i,k)) then
      p0=abs(a0(i,k))
      l=i
    endif
  next i
  if l<>k then
    for j=k to n
      swap a0(k,j),a0(l,j)
    next j
    swap b0(k),b0(l)
  endif

  p0=a0(k,k)
  for j=k+1 to n
    a0(k,j)=a0(k,j)/p0
  next j
  b0(k)=b0(k)/p0

  for i=k+1 to n
    p0=a0(i,k)
    for j=k+1 to n
      a0(i,j)=a0(i,j)-a0(k,j)*p0
    next j
    b0(i)=b0(i)-b0(k)*p0
  next i
next k

x0(n)=b0(n)/a0(n,n)
for k=n-1 to 0 step -1
  s0=0
  for j=k+1 to n
    s0=a0(k,j)*x0(j)+s0
  next j
  x0(k)=b0(k)-s0
next k

print
print "Solution:"
for k=0 to n
  print "X("; k+1; ")="; x0(k)
next k
end
