***** Calculator program by Genji OKADA  7/27/91 *****

print "*** Calculator ***"
print "C=+-*/^,xyz,XYZ,neg,dup,pop,swap,sqr,sin,cos,tan,atn,log,lgt,exp,hsn,(end)"
print "                ~   ~   ~    ~    ~  ~   ~   ~   ~   ~    ~  ~   ~"
on error goto resetsp

integer a :* location of s$
integer d :* ascii data
integer k :* stack pointer
integer err :* error flag

real st	:* value stack
real mem :* memory x,y,z

dim st(100),mem(10,2)
a=loc(s$)

@resetsp
k=0 :* reset stack pointer
value =err :* reset error flag

@start
print %1i k;
line input s$
if s$="end" then stop


@skipnext
if err=0 else print " error" :goto resetsp

while asc(s$)=' '
5 call incptr
wend

value =d
if !=9 then 5
if !=',' then 5
if !=0 then if k<=0 then @start else print st(k): goto @start

if !='.' then 10
if !>='0' then if !<='9' then
10 call number
  goto skipnext
endif

switch !

case '='
  if k>0 then print st(k) else print "empty!!"
  break

case 'C' :* clear
  k=0
  break

case '+'
  call calcpop(st(k-1)+st(k))
  break

case '-'
  call calcpop(st(k-1)-st(k))
  break

case '*'
  call calcpop(st(k-1)*st(k))
  break

case '/'
  call calcpop(st(k-1)/st(k))
  break

case 'n' :* negate
  st(k)=-st(k)
  break

case 'd' :* duplicate
  call pushval(st(k))
  break

case 'p' :* pop
  if k>0 then k=k-1 else err=-1
  break

case 'w' :* swap
  if k>1 then swap st(k-1),st(k) else err=-1
  break

case 'q' :* sqrt()
  st(k)=sqr(st(k))
  break

case 's' :* sin()
  st(k)=sin(st(k))
  break

case 'c' :* cos()
  st(k)=cos(st(k))
  break

case 't' :* tan()
  st(k)=tan(st(k))
  break

case 'a' :* arctan()
  st(k)=atn(st(k))
  break

case 'l' :* ln()
  st(k)=log(st(k))
  break

case 'g' :* log10()
  st(k)=lgt(st(k))
  break

case 'e' :* exp()
  st(k)=exp(st(k))
  break

case 'h' :* sinh()
  st(k)=hsn(st(k))
  break

case '^'
  call calcpop(st(k-1)^st(k))
  break

case 'x'
case 'y'
case 'z'
  call pushval(mem(call_index,d-'x'))
  break

case 'X'
case 'Y'
case 'Z'
  mem(call_index,d-'X')=st(k)
  break

default
  err=-1
  break
swend

call incptr
goto skipnext


***** subroutine *****
subroutine incptr
  dpoke a,dpeek(a)+1
  return
subend

subroutine number
  real x0
  x0=val(s$)
  /byte &96 :* xchg si,ax
  dpoke a,!
  call pushval(x0)
  return
subend

subroutine pushval(x0)
  real x0
  if k<100 then
    k=k+1
    st(k)=x0
  else
    print "stack over"
    err=-1
  endif
  return
subend

subroutine index
  integer x
  x=peek(dpeek(a)+1)-'0'
  if !>=0 then if !<=9 then call incptr :return x
  return 10
subend

subroutine calcpop(x0)
  real x0
  if k>1 then k=k-1 :st(k)=x0 else err=-1
  return
subend

end
