options /wl=&1FF8 /wp=&1ffe /ws=512 -#O /wb=256 /wt=1024 /wi=1024 

merge "mshrink.ltb"

/push cs
/pop ax
print "CS:"; %4H !,
/push ds
/pop ax
print "DS:"; %4H !,
/push es
/pop ax
print "ES:"; %4H !,
/push Ss
/pop ax
print "SS:"; %4H !



print "mysize", float(my__size)*16; "bytes"
print "PSP-Seg.:"; %4H psp__seg, 
print "First free Seg.:"; %4H nxt__mcb

merge "alloc.ltb"

integer par, msize
par=0
msize=0
/push es
/mov ax, psp__seg
/sub ax, 1
/mov es, ax
/push si
/mov si,3
/es /mov ax, [si]
/mov par, ax
/pop si
/pop es
print "Paragraphs (MCB): ";%4H par
/mov ah, &48
/mov bx, &200
/int &21
/mov par, ax
/mov msize, bx
/jnc @ok
print "Alloc failed. ";float(msize)*16;" bytes available."
goto end   
@ok
print "segment:";%4H par, 
print "size bytes:";float(msize)*16; " paragraphs:"; %4H msize
@end

integer seg
real msizef
print "test alloc library"
print "free memory: ";
msize = call_getMemAvail
seg = msize
msizef = 0
if seg < 0 then
  /mov ax, seg
  /and ax, &7FFF
  /mov seg, ax
  msizef = (float(&7FFF)+1.0)*16
endif
msizef = msizef+ float(seg)*16
print "bytes :";msizef; " paragraphs:"; %4H msize
print "allocate 25 paragraphs"
seg = call_allocMem(25)
print "segment is ";%4H seg
print "dealloc"
call freeMem(seg)
print "set best fit strategy"
call setAllocStrategy(_mstrat_best)
seg = call_allocMem(25)
print "segment is ";%4H seg
print "dealloc"
call freeMem(seg)
print "set last fit strategy"
call setAllocStrategy(_mstrat_last)
seg = call_allocMem(25)
print "segment is ";%4H seg
print "dealloc"
call freeMem(seg)
end
